unit FFT_DconvMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids, system.Types, system.DateUtils;

type
  D2array = array of array of Double;
  TDarray = array[0..0] of Double;
  PDarray = ^TDarray;
  TMarray = array[0..0] of integer;
  PMarray = ^TMarray;
  M2array = array of integer;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    MaskingBtn: TButton;
    RadioGroup1: TRadioGroup;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    SigumaGrid: TStringGrid;
    sourceBtn: TButton;
    RangeEdit: TLabeledEdit;
    Timer1: TTimer;
    RepaintBtn: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    magnificationEdit: TLabeledEdit;
    TrimmingBtn: TButton;
    Memo1: TMemo;
    MaskSizeEdit: TLabeledEdit;
    AngleEdit: TLabeledEdit;
    FrameBtn: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MaskingBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure sourceBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RangeEditChange(Sender: TObject);
    procedure RepaintBtnClick(Sender: TObject);
    procedure TrimmingBtnClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MaskSizeEditChange(Sender: TObject);
    procedure AngleEditChange(Sender: TObject);
    procedure FrameBtnClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure FFT2(var a_rl, a_im: D2array; inv: Integer);
    procedure cstb(length: Integer; inv: integer; var sin_tbl, cos_tbl: array of double);
    procedure rvmtx(var a, b, c, d: D2array; xysize, yxsize: Integer);
    procedure Imageout(Image: TBitmap);
    procedure Trimming;
    procedure TrimmingImage;
    procedure trimming_imageout(Image: TBitmap);
    procedure TestRoutine;
    function LineDataset: boolean;
    procedure Edge_processing;
    procedure fft(a_rl, a_im: PDarray; length: integer; inv: integer;
                  sin_tbl, cos_tbl: PDarray; m: PMarray);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;                           // \gTCY


  Line_blur     = 0;
  Deconvolution = 1;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // 摜\prbg}bv
  SHeight       : Integer;                    // ̓f[^[摜
  SWidth        : Integer;                    // ̓f[^[摜
  GHeight       : Integer;                    // vZf[^[摜
  GWidth        : Integer;                    // vZf[^[摜
  THeight       : Integer;                    // g~Of[^[摜
  TWidth        : Integer;                    // g~Of[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C

  threshold     : Double;                     // ͈͎w
  gaus          : integer;                    // KEVAzTCY

  Gaussian : array of array of double;
  TrimmingF     : boolean;          // g~OtO
  trimTop       : integer;          // g
  trimLeft      : integer;          // g
  trimHeight    : integer;          // g
  trimWidth     : integer;          // g
  TrimScale     : double;           // gXP[
  Sctext        : string;

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : Trect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := Round(Image.Width * magnification);
  MH := Round(Image.Height * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
end;

//--- rvmtx --- Qf[^̓]u -------------------------------------------
//    a:        Q̓f[^1
//    b:        Qo̓f[^1
//    c;        Q̓f[^2
//    d;        Qo̓f[^2
//    xysize:   ,f[^
//    yxsize:   ,f[^
//-----------------------------------------------------------------------------
procedure TForm1.rvmtx(var a, b, c, d: D2array; xysize, yxsize: Integer);
var
  i, j: integer;
begin
  for i := 0 to yxsize - 1 do
    for j := 0 to  xysize - 1 do begin
      b[j, i] := a[i, j];
      d[j, i] := c[i, j];
    end;
end;

// ------------------------V FFTvZ ------------------------------
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    length:  f[^[
//    inv:     ϊtO F = -1 ϊ F = 1 tϊ
//    sin_tbl, cos_tbl sin, cos e[u
//    m        ]qobt@
// -----------------------------------------------------------------
procedure TForm1.fft(a_rl, a_im: PDarray; length: integer; inv: integer;
                     sin_tbl, cos_tbl: PDarray; m: PMarray);
var
  I, J, nd, ns, L, arg, it, ib: integer;
  a, b, t : double;
begin
  nd := length div 2;           // f[^1/2
  ns := nd;                     // 2i̍ŏʒl
  while (ns > 0) do begin       // 2i̍ŏʂ̒l0ɂȂ܂ŌJԂ
    L := 0;                     // L=0
    while L < length do begin   // L̒llength܂ŁA
      arg := m[L] div 2;        // ]q=Ỏ]q̒l/2       m[0]͏0
      for it := L to L + ns - 1 do begin    // it̒lL̒lL+2i̍ŏʂ̒l܂ŌJԂ
        ib := it + ns;                      // ibit + 2i̍ŏʂ̒l
        a := a_rl[ib] * cos_tbl[arg] - a_im[ib] * sin_tbl[arg];
        b := a_im[ib] * cos_tbl[arg] + a_rl[ib] * sin_tbl[arg];
        a_rl[ib] := a_rl[it] - a;
        a_im[ib] := a_im[it] - b;
        a_rl[it] := a_rl[it] + a;
        a_im[it] := a_im[it] + b;
        m[it] := arg;           // m[it]ɉ]qۑ
        m[ib] := arg + nd;      // m[ib]ɉ]q + f[^1/2 ۑ
      end;
      L := L + ns + ns;         // L̒l0n܂ŁA2~ŏʂ̒lstepŌJԂ
    end;
    ns := ns div 2;             // 2i̍ŏʂ̒lJ艺
  end;
  if inv = 1 then begin         // inv 1 gϊ -1 tϊ 2 tB^[
    t := 1 / length;
    for I := 0 to length - 1 do begin
      a_rl[I] := a_rl[I] * t;
      a_im[I] := a_im[I] * t;
    end;
  end;
  for I := 0 to length - 1 do begin     // f[^[̕בւrbg]
    if I < m[I] then begin
      J := m[I];
      t := a_rl[I];
      a_rl[I] := a_rl[J];
      a_rl[J] := t;
      t := a_im[I];
      a_im[I] := a_im[J];
      a_im[J] := t;
    end;
  end;
end;

//--- cstb --- SIN,COSe[u쐬 --------------------------------------------
//    length:     f[^
//    inv:        1: ees, -1: tees
//    sin_tbl:    SINvZpe[u
//    cos_tbl:    COSvZpe[u
//-----------------------------------------------------------------------------
procedure TForm1.cstb(length: Integer; inv: Integer; var sin_tbl, cos_tbl: array of double);
var
  i : Integer;
  xx, arg : Double;
begin
  xx := - PI * 2.0 / length;
  if inv < 0 then xx := - xx;
  for i := 0 to length - 1 do begin
    arg := i * xx;
    sin_tbl[i] := sin(arg);
    cos_tbl[i] := cos(arg);
  end;
end;

//--- fft2 --- Qees̎s ---------------------------------------------
//   iGWidthCGHeightQׂ̂̏ꍇɌ܂j
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    inv:    1: eesC-1: tees
//  fft̃[`ɒln̂Ƀ|C^[ @@gpĂ܂
//  񎟌z̈snׂɎgpĂ܂B
//  ꎟ̔zn̂ |C^[ @ gpKv͂܂B
//  z̒ln̂𓝈ꂷ̂ɎgpĂ܂B
//-----------------------------------------------------------------------------
procedure TForm1.FFT2(var a_rl, a_im: D2array; inv: Integer);
var
  b_rl      : D2array;              // f[^]uƗpzij
  b_im      : D2array;              // f[^]uƗpzi)
  hsin_tbl  : array of Double;      // pSINvZpe[u
  hcos_tbl  : array of Double;      // pCOSvZpe[u
  vsin_tbl  : array of Double;      // pSINvZpe[u
  vcos_tbl  : array of Double;      // pCOSvZpe[u
  m_x       : M2array;              // f[^[̕בւrbg]with
  m_y       : M2array;              // f[^[̕בւrbg]Height
  i         : Integer;
begin
  // z̊m
  SetLength(b_rl, GWidth, GHeight);
  SetLength(b_im, GWidth, GHeight);
  SetLength(hsin_tbl, GWidth);
  SetLength(hcos_tbl, GWidth);
  SetLength(vsin_tbl, GHeight);
  SetLength(vcos_tbl, GHeight);
  SetLength(m_x, GWidth);
  SetLength(m_y, GHeight);

  cstb(GWidth,  inv, hsin_tbl, hcos_tbl);     // pSIN,COSe[u쐬
  cstb(GHeight, inv, vsin_tbl, vcos_tbl);     // pSIN,COSe[u쐬
  // ̂ees
  for i := 0 to GHeight - 1 do
    fft(@a_rl[i][0], @a_im[i][0], GWidth, inv, @hsin_tbl[0], @hcos_tbl[0], @m_x[0]);
  // Qf[^̓]u XY̒lւ܂
  // fft1corescanXɂoȂׂɍs܂
  rvmtx(a_rl, b_rl, a_im, b_im, GWidth, Gheight);
  // ̂ees
  for i := 0 to GWidth - 1 do
    fft(@b_rl[i][0], @b_im[i][0], GHeight, inv, @vsin_tbl[0], @vcos_tbl[0], @m_y[0]);
  // Qf[^̓]u XY̒lւ܂
  // XYւĂ̂Ō֖߂܂
  rvmtx(b_rl, a_rl, b_im, a_im, Gheight, GWidth);
end;

//---------- u␳f[^[̍쐬 -----------
//@pxƒ̐ݒ
//---------------------------------------------
function TForm1.LineDataset: boolean;
var
  X, Y, CH   : integer;
  KS, Angle  : Double;
  Total   : Double;
  MDIV2, MDIV : integer;
  MatSize : integer;
  rad, ypos, xpos : Double;
begin
  result := False;
  val(MaskSizeEdit.Text, gaus, CH);
  if CH <> 0 then begin
    application.MessageBox('MaskSize ͂ɊԈႢ܂B', 'MaskSize', 0);
    exit;
  end;
  if gaus < 3 then begin
    application.MessageBox('MaskSize ̒l܂B', 'MaskSize', 0);
    exit;
  end;
  if (gaus > GWidth div 5) or (gaus > GHeight div 5) then begin
    application.MessageBox('MaskSize ̒l傫߂܂B', 'MaskSize', 0);
    exit;
  end;
  if gaus mod 2 = 0 then begin
    application.MessageBox('MaskSizeɂĂB', 'MaskSize', 0);
//    exit;
  end;
  gaus := gaus + 2;
  val(AngleEdit.Text, Angle, CH);
  if CH <> 0 then begin
    application.MessageBox('pxɊԈႢ܂B', 'px', 0);
    exit;
  end;
  repeat
    if Angle < 0 then Angle := Angle + 180;
    if Angle >= 180 then Angle := Angle - 180;
  until (Angle >= 0) and (Angle < 180);
  rad := Angle / 180 * pi;
  if rad > 0 then rad := -rad;
  setlength(Gaussian, gaus, gaus);
  MatSize := gaus;
  // XgOObh̐ݒ
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  SigumaGrid.RowCount := MatSize + 1;
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  MDIV := MDIV2;
  if MatSize mod 2 = 0 then MDIV := MDIV2 - 1;
  for Y := - MDIV to MDIV2 do SigumaGrid.Cells[0 , Y + MDIV + 1] := intTostr(Y);
  for X := - MDIV to MDIV2 do SigumaGrid.Cells[X + MDIV + 1,  0] := intTostr(X);

  // }XNf[^[vZƕ\
  Total := gaus - 2;
  for Y := - MDIV to MDIV2 do
    for X := - MDIV to MDIV2 do begin
      Gaussian[X + MDIV, Y + MDIV] := 0;
    end;

  for X := - MDIV2 +1 to MDIV -1 do begin
    ypos := sin(rad) * X;
    xpos := cos(rad) * X;
    Y := round(ypos);
    CH := round(xpos);
    Gaussian[Y + MDIV, CH + MDIV] := 1
  end;

  // tB^[̒lϊ vlPɂȂ悤ɕϊ܂
  for Y := - MDIV to MDIV2 do
    for X := - MDIV to MDIV2 do begin
      KS := Gaussian[X + MDIV, Y + MDIV] / Total;
      Gaussian[X + MDIV, Y + MDIV] := KS;
      // Obhɕ\
      SigumaGrid.Cells[Y  + MDIV + 1, X + MDIV + 1] := FloatTostrF(KS, ffFixed, 6,5);
    end;
  result := true;
end;

//-------------------------------------------------------------------------------------------------
type
  TPrgbarry = array[0..0] of Trgbtriple;  // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray = ^TPrgbarry;                 // |C^[
                                          // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
var
  arBlu       : D2array;             // f[^io͌p)
  aiBlu       : D2array;             // f[^io͌p)
  PBA         : Prgbarray;           // RGBtriple |C^[
  sttT, stpT  : TDateTime;

//-----------------------------------------------------
// tB^[vZ
// ^C}[ő҂킹^C}[݂ŃtB^[vZ
//-----------------------------------------------------
procedure TForm1.MaskingBtnClick(Sender: TObject);
begin
  MaskingBtn.Enabled := False;
  FileOpenBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  FrameBtn.Enabled := False;
  sourceBtn.Enabled := False;
  TrimmingBtn.Enabled := False;
  if TrimmingF then TrimmingImage;
  Memo1.Clear;
  Memo1.Lines.Add('vZ');
  sttT := Now;
  Memo1.Lines.Add(' Start ' + DateTimeToStr(sttT));
  Timer1.Enabled := True;   // \҂킹^C}[X^[g
end;

//--------------------------------
// {^\XV҂킹
// tB^[vZ
//--------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if (RadioGroup1.ItemIndex = Line_blur) or (RadioGroup1.ItemIndex = Deconvolution) then TestRoutine;

  FileSaveBtn.Enabled := True;
  FileOpenBtn.Enabled := True;
  RepaintBtn.Enabled := True;
  sourceBtn.Enabled := True;
  FrameBtn.Enabled := True;
  stpT := Now;
  Memo1.Lines.Add(' End   ' + DateTimeToStr(stpT));
  Memo1.Lines.Add(' interval sec ' + floatTostr(SecondsBetween(sttT, stpT)));
end;

//----------------------------
// ČvZ
//----------------------------
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.RangeEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.MaskSizeEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.AngleEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

//-------------------------------------
// Edge processing
// 摜̉Gray`Fɕω܂
//-------------------------------------
procedure TForm1.Edge_processing;
var
  x, y : integer;
  mdata : array of double;
  gdata : array of byte;
begin
  setlength(mdata, gaus);
  setlength(gdata, gaus);
  for y := 0 to gaus - 1 do begin
    mdata[y] := y / gaus;
    gdata[gaus - 1 - y] := round((128 / gaus) * y);
  end;
  for y := 0 to gaus - 1 do
    for x := y to SWidth - y - 1 do
      begin
        arBlu[y, x] := round(arBlu[y, x] * mdata[y]  + gdata[y]);
        arBlu[Sheight - y - 1, x] := round(arBlu[Sheight - y - 1, x] * mdata[y] + gdata[y]);
      end;
  for x := 0 to gaus - 1 do
    for y := x + 1 to SHeight - x - 2 do
      begin
        arBlu[y, x] := round(arBlu[y, x] * mdata[x] + gdata[x]);
        arBlu[y, Swidth - x - 1] := round(arBlu[y, Swidth - x - 1] * mdata[x] + gdata[x]);
      end;
end;

//--------------------------------------
// {JV  fR{[V
//--------------------------------------
procedure TForm1.TestRoutine;
var
  conv_real   : D2array;             // tB^[p
  conv_image  : D2array;             // tB^[p
  nx, ny, x, y: integer;
  Step        : integer;
  CH          : integer;
  Color       : byte;
  rdr         : Double;
  rdi         : Double;
  r, i        : Double;
  half_cw     : integer;
  half_ch     : integer;
  DI          : Integer;
begin
  if not LineDataset then exit;
  application.ProcessMessages;
  val(RangeEdit.Text, threshold, CH);
  if CH <> 0 then begin
    application.MessageBox('Deconv Range ͂ɊԈႢ܂B', 'Range', 0);
    exit;
  end;
  if threshold <= 0 then begin
    application.MessageBox('Deconv Range [yѕł͂܂B', 'Range', 0);
    exit;
  end;
  if threshold > 1 then begin
    application.MessageBox('Deconv Range 1𒴂ꍇ摜͂ȂȂ܂B', 'Range', 0);
    exit;
  end;

  // z̊m
  // PC̐擪|C^[gp [V Lines, H Lines] ɂȂ܂
  setlength(conv_real,  GHeight, GWidth);
  setlength(conv_image, GHeight, GWidth);
  setlength(arBlu, GHeight, GWidth);
  setlength(aiBlu, GHeight, GWidth);

  // TCY Qnɏ TCY̍Ȃ͍F͊DFɂȂ܂
  if checkbox2.Checked then Color := 128
                       else Color := 0;
  if (SWidth <> GWidth) or (GHeight <> SHeight) then begin
    for y := 0 to Gheight - 1 do begin
      PBA := InputDBitmap.ScanLine[Y];
      if y < Sheight then begin
        for x := SWidth to GWidth - 1 do begin
          PBA[x].rgbtBlue  := Color;
          PBA[x].rgbtGreen := Color;
          PBA[x].rgbtRed   := Color;
        end;
       end
       else begin
        for x := 0 to GWidth - 1 do begin
          PBA[x].rgbtBlue  := Color;
          PBA[x].rgbtGreen := Color;
          PBA[x].rgbtRed   := Color;
        end;
      end;
    end;
  end;

  // gtB^[̐ݒ   lZbg
  half_cw := gaus div 2;
  half_ch := gaus div 2;
  if gaus mod 2 = 0 then begin
    half_cw := half_cw - 1;
    half_ch := half_ch - 1;
  end;
  for y := 0 to gaus - 1 do
    for x := 0 to gaus -1 do  begin
      nx := GWidth - half_cw + x;
      ny := Gheight - half_ch + y;
      if nx >= GWidth   then nx := nx - GWidth;
      if ny >= Gheight  then ny := ny - GHeight;
      conv_real[ny][nx] := Gaussian[y][x];
    end;

  // gtB^[t[Gϊ܂ RGBOFʂł
  // @tB^[̏ꍇAϊAf[^[ɂ鏜ZȂ悤ɂ܂
  FFT2(conv_real, conv_image, 2);

  // RGB PFƂFFŤvZ܂B
  for Step := 0 to 2 do begin
    // 摜ǂݍ݁CQFFT̓̓f[^ɕϊ܂
    for y := 0 to Gheight - 1 do begin
      PBA := InputDBitmap.ScanLine[Y];
      for x := 0 to GWidth - 1 do begin
      // J[pOF        
        case Step of
          0 :  arBlu[y, x] := PBA[x].rgbtBlue;
          1 :  arBlu[y, x] := PBA[x].rgbtGreen;
          2 :  arBlu[y, x] := PBA[x].rgbtRed;
        end;
        aiBlu[y, x] := 0.0;   // 
      end;
    end;

    if checkbox2.Checked then Edge_processing;
    // QFFTs 摜gɕϊ܂
    FFT2(arBlu, aiBlu, 1);

    // {JV@---------------------------
    if RadioGroup1.ItemIndex = Line_blur then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // tB^[̎{
          r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
          i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
          arBlu[y][x] := r;
          aiBlu[y][x] := i;
        end;
    end;
    //---------------------------------------------------

    // fR{[V -------------------------
    if RadioGroup1.ItemIndex = Deconvolution then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // fR{[VW
          rdr := abs(conv_real[y][x]);
          rdi := abs(conv_image[y][x]);
          // {JVƂ͋tȂ̂ŁAtɂ܂
          // threshold͒lꍇt̒l傫Ȃ肷̂Őlł
          // threshold̓[ł̏Z̖h~܂
          if rdr > threshold then rdr := 1 / conv_real[y][x]
                             else
                               if checkbox1.Checked then rdr := 0
                                                    else rdr := 1 / threshold;
          if rdi > threshold then rdi := 1 / conv_image[y][x]
                             else
                               if checkbox1.Checked then rdi := 0
                                                    else rdi := 1 / threshold;
          // fR{[V̐
          r := arBlu[y][x] * rdr - aiBlu[y][x] * rdi;
          i := arBlu[y][x] * rdi + aiBlu[y][x] * rdr;

          arBlu[y][x] := r;
          aiBlu[y][x] := i;
      end;
    end;
    //---------------------------------------------------

    // tFFTsāCtB^ꂽg摜ɖ߂܂
    FFT2(arBlu, aiBlu, -1);

    // ʂ摜f[^ɕϊ
    for Y := 0 to Sheight - 1 do begin
      PBA := OutputBitmap.ScanLine[Y];
      for X := 0 to SWidth - 1 do begin
        DI := Round(arBlu[y][x]);
        if DI > 255 then DI := 255;
        if DI <   0 then DI := 0;
        case Step of
          0: PBA[x].rgbtBlue    := DI;
          1: PBA[x].rgbtGreen   := DI;
          2: PBA[x].rgbtRed     := DI;
        end;
      end;
    end;
  end;
  Imageout(OutputBitmap);               // o͘gɕϔ{o

  finalize(arBlu);
  finalize(aiBlu);
end;

//--------------
// 摜̕\
//--------------
procedure TForm1.sourceBtnClick(Sender: TObject);
begin
  Imageout(InputDBitmap);               // o͘gɕϔ{o
end;

//----------------------------
// vZʂ̍ĕ\
//----------------------------
procedure TForm1.RepaintBtnClick(Sender: TObject);
begin
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//-----------------------
// g\{ݒ
//-----------------------
procedure TForm1.FrameBtnClick(Sender: TObject);
begin
  magnificationEdit.Text := Sctext;
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//--------------------------------------------------
// Jt@C̉摜\
//--------------------------------------------------
procedure TForm1.trimming_imageout(Image: TBitmap);
begin
  if Image.Width >= Image.Height then begin
    Image1.Width := ImageHWC;
    image1.Height := round((ImageHWC) * image.Height / Image.Width);
  end
  else begin
    Image1.Height := ImageHWC;
    image1.Width := round((ImageHWC) * image.Width / Image.Height);
  end;
  Image1.Picture.Bitmap.SetSize(Image1.Width, image1.Height);
  Image1.Canvas.StretchDraw(Rect(0, 0, Image1.Width, image1.Height), Image);    // o͘gɕϔ{o
  magnificationEdit.Text := floatTostrF(Image1.Width / Image.Width, ffGeneral, 4, 2);
  Sctext := magnificationEdit.Text;
end;

//---------------------------------------------------------------
// 摜TCYc2^nƂ鎞A摜̏c𒴂Ȃʂ
// 摜TCYcݒ肵A摜o܂B
// o܂B
//---------------------------------------------------------------
procedure TForm1.TrimmingBtnClick(Sender: TObject);
begin
  Trimming;
end;

var
  Drawing       : Boolean;                    // }EXIg\tO
  Origin        : TPoint;                     // }EXX^[gʒu
  EndPoint      : TPoint;                     // }EXAbvʒu
  NewMove       : Boolean;                    // }EXVړ

//-------------------------------------------------------
// \ꂽ摜ɁA2^n TCY̎og\܂
//-------------------------------------------------------
procedure TForm1.Trimming;
var
  nx : integer;
begin
  if TrimmingF then begin
    if Drawing then begin
      Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
      if not NewMove then begin
        Image1.Canvas.Rectangle(trimLeft, trimtop, trimWidth + trimLeft, trimHeight + trimTop); // O̐
        Image1.Canvas.Pen.Mode := pmCopy;                   // y[hʏ
      end;
    end;
    TrimmingF := False;
    Drawing := False;
    exit;
  end;
  if not TrimmingF then TrimmingF := true;
  nx := 1;
  // f[^̂Qׂ̂vZ
  // 摜Ɠ2^n̉摜TCY擾
  repeat
    nx := nx * 2;
    if (nx <= SWidth)  then TWidth := nx;             // g~O
    if (nx <= SHeight) then THeight := nx;            // g~O
  until (nx >= SWidth) and (nx >= SHeight);
  trimTop  := 0;                                      // g
  trimLeft := 0;                                      // g
  TrimScale   := Image1.Width / SWidth;
  trimHeight  := round(THeight * TrimScale);          // g
  trimWidth   := round(TWidth  * TrimScale);          // g
  Image1.Canvas.Brush.Style := bsClear;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Pen.Color := clred;
  Image1.Canvas.Pen.Mode := pmNotXor;                 // y[h Not Xor
  Image1.Canvas.Rectangle (trimLeft, trimtop, trimWidth, trimHeight);
  Image1.Canvas.Pen.Mode := pmCopy;                   // y[hʏ
  NewMove := False;
  Drawing := True;
end;

//----------------------------------------------------------
// ogŕ\ꂽ摜o
// InputDBitmapɃZbg܂B
//----------------------------------------------------------
procedure TForm1.TrimmingImage;
var
  X, Y : integer;
  T, L : integer;
  PBB  : Prgbarray;
begin
  // 2^n̉摜TCYɐݒ
  InputDBitmap.Width := TWidth;
  InputDBitmap.Height := THeight;
  T := round(trimTop / TrimScale);
  L := round(trimLeft / TrimScale);
  if SWidth - (L + TWidth) < 0 then L := L - (SWidth - (L + TWidth));
  if SHeight - (T + THeight) < 0 then T := T - (SHeight - (T + THeight));
  for Y := T to T + THeight - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    PBB :=  InputDBitmap.ScanLine[Y - T];
    for X := L to L + TWidth - 1 do begin
      PBB[X - L].rgbtBlue := PBA[X].rgbtBlue;
      PBB[X - L].rgbtGreen := PBA[X].rgbtGreen;
      PBB[X - L].rgbtRed := PBA[X].rgbtRed;
    end;
  end;
  GWidth := TWidth;
  GHeight := THeight;
  SWidth  := TWidth;
  SHeight := THeight;
  OutputBitmap.Width := GWidth;
  OutputBitmap.Height:= GHeight;
  // g~OÎŃtO
  TrimmingF := False;
  Drawing := False;
  // g~O̕\TCYݒ
  if GWidth >= GHeight then begin
    Image1.Width := ImageHWC;
    image1.Height := round((ImageHWC) * GHeight / GWidth);
  end
  else begin
    Image1.Height := ImageHWC;
    image1.Width := round((ImageHWC) * GWidth / GHeight);
  end;
  Image1.Picture.Bitmap.SetSize(Image1.Width, image1.Height);
  magnificationEdit.Text := floatTostrF(Image1.Width / GWidth, ffGeneral, 4, 2);
  Sctext := magnificationEdit.Text;
end;

//---------------------------------------------------------
// 摜ogړׂ̈̃}EX_Eɂݒ
//---------------------------------------------------------
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not TrimmingF then exit;
  Origin := Point(X, Y);                                                  // W̕ۑ
  NewMove := False;
  Drawing := True;
end;

//---------------------------------------------------------
// }EẌړɂogړ
//---------------------------------------------------------
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  defX, defy : integer;
begin
  if Drawing and (Shift = [ssLeft]) then begin
    Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
    if not NewMove then begin
      Image1.Canvas.Rectangle(trimLeft, trimtop, trimWidth + trimLeft, trimHeight + trimTop); // O̐
    end;
    EndPoint := point(X, Y);                                              // VWۑ
    defX := EndPoint.X - Origin.X;
    defY := EndPoint.Y - Origin.Y;
    if (trimLeft + defX >= 0) and (trimWidth + trimLeft + defX < image1.Width) then
      trimLeft := trimLeft + defX;
    if (trimtop + defY >= 0) and (trimHeight + trimTop + defY < image1.Height) then
      trimtop  := trimtop  + defY;
    Origin := Point(X, Y);
    Image1.Canvas.Rectangle(trimLeft, trimtop, trimWidth + trimLeft, trimHeight + trimTop);
    NewMove := False;
    Image1.Canvas.Pen.Mode := pmCopy;                                     // y[hʏ
  end;
end;

//------------------------------------------------
// t@C̃I[v
//------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  XF, YF      : Boolean;
  nx2         : integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                   // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        SHeight := WIC.Height;                                // 摜擾
        SWidth  := WIC.Width;                                 // 摜

        // OutputBitmapɌ摜ꎞۑ
        OutputBitmap.Width  := SWidth;
        OutputBitmap.Height := SHeight;
        OutputBitmap.Canvas.Draw(0, 0, WIC);     // rbg}bvɕ`tH[}bgϊ

        //---------------------------------------------------------------
        // 摜TCY傫 摜̃TCY Qnɐݒ
        // InputDBitmap Ɍ摜ɃRs[
        XF := False;
        YF := False;
        nx2 := 1;
        // f[^̂Qׂ̂vZ
        // 摜Ɠ傫2^n̉摜TCY擾
        repeat
          nx2 := nx2 * 2;
          if (nx2 >= SWidth) and (XF = False) then begin
            XF := True;
            GWidth := nx2;
          end;
          if (nx2 >= SHeight) and (YF = False) then begin
            YF := True;
            GHeight := nx2;
          end;
        until (nx2 >= SWidth) and (nx2 >= SHeight);

        // 2^n̉摜TCYɐݒ
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        // SʍFݒ  Canvas 摜
        VRect := Rect(0, 0, GWidth, GHeight);
        InputDBitmap.Canvas.Brush.Style := bsSolid;
        InputDBitmap.Canvas.Brush.Color := clblack;
        InputDBitmap.Canvas.FillRect(VRect);
        // WIC摜
        InputDBitmap.Canvas.Draw(0, 0, WIC);
        //--------------------------------------------------------------
      finally
        WIC.Free;                                   // TWICImage 
      end;
    end
    else exit;
  trimming_imageout(OutputBitmap);                  // o͘g킹Ăɕϔ{o

  MaskingBtn.Enabled := True;
//  sourceBtn.Enabled := True;
  radiogroup1.Enabled := True;
  TrimmingBtn.Enabled := True;
  TrimmingF := False;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;

end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  top := (Screen.height - Height) div 2;
  left := (Screen.Width - Width) div 2;
  Timer1.Enabled := False;
  Timer1.Interval := 200;
  Image1.Width  := ImageHWC;
  Image1.Height := ImageHWC;
  ScrollBox1.Height := ImageHWC + ScrollBox1.BevelWidth * 4;
  ScrollBox1.Width  := ImageHWC + ScrollBox1.BevelWidth * 4;
  Image1.Top := 0;
  Image1.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  radiogroup1.Items.Add('Line blur');
  radiogroup1.Items.Add('Deconvolution');

  radiogroup1.ItemIndex := 1;
  radiogroup1.Enabled := False;
  MaskingBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  sourceBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  TrimmingBtn.Enabled := False;
  FrameBtn.Enabled := False;
  Sctext := '1';
end;

// I
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;

end.
